#!/usr/bin/perl
#
# Genera nominativi casuali dal Callbook in DB3
# Creato da Franco, IK7XJA
# comando dbview: dbview -b -t -d '|' WORLD.BOK
#
# Recupero il parametro passato per il numero di
# nominativi da estrarre; se non esiste, vale 50
my $Quanti_nominativi = $ARGV[0] ;
if (!$Quanti_nominativi) {
   $Quanti_nominativi = 50 ;
}
# Imposto il max dei nominativi USA ad ¼ del totale
my $Max_Nominativi_USA = $Quanti_nominativi / 4 ;
# Definisco la variabile del file del Db (deve stare nella directory)
my $Db = 'WORLD.BOK' ;
# Definisco il comando di DbView
my $Dbview = qq{/usr/bin/dbview -b -t -d '|'} ;
# Definisco array per i risultati
undef my @Archivio ;
# Lancio il comando in Shell
my $Comando = "$Dbview $Db" ;
my $Res = `$Comando` ;
# Ed assegno il risultato ottenuto all'array
@Archivio = split /\n/, $Res ;
$Res = '' ;
# Comincio l'estrazione dei nominativi casuali
# inizializzando i contatori
my $Max = @Archivio ;
undef my %Generati ;
undef my @Nominativi_estratti ;
my $Quanti_Nominativi_USA = 0 ;
my $Estratti = 0 ;
while ($Estratti < $Quanti_nominativi) {
   my $random_number = int(rand($Max));
   if (!defined($Generati{$random_number})) {
      my $Call = (split /\|/, $Archivio[$random_number])[0] ;
      $Generati{$random_number} = 1 ;
      # conto i nominativi che cominciano per W, N e K (=USA)
      if (($Call =~ /^N/)||($Call =~ /^K/)||($Call =~ /^W/)) {
         $Quanti_Nominativi_USA++ ;
         if ($Quanti_Nominativi_USA > $Max_Nominativi_USA) {
            next ;
         } else {
            $Estratti++ ;
            push(@Nominativi_estratti, $Call) ;
         }
      } else {
         $Estratti++ ;
         push(@Nominativi_estratti, $Call) ;
      }
   }
}
# Preparo righi da 55 caratteri al massimo
my $Rigo = '' ;
foreach my $C(@Nominativi_estratti) {
   $Rigo .= "$C " ;
   if (length($Rigo)>55) {
      print " $Rigo\n" ;
      $Rigo = '' ;
   }
}
exit ;